package com.maroontress.coverture;

import java.util.LinkedList;
import java.util.Queue;

/**
   եդ褹뤿ΥФǤ
*/
public final class Solver {
    /** ¹ԲȽȤ˥֥åɲä륭塼Ǥ */
    private Queue<Block> validBlocks;

    /** ¹ԲʤȤ˥֥åɲä륭塼Ǥ */
    private Queue<Block> invalidBlocks;

    /**
       󥹥󥹤ޤ
    */
    public Solver() {
	validBlocks = new LinkedList<Block>();
	invalidBlocks = new LinkedList<Block>();
    }

    /**
       ¹ԲȽ֥åɲäޤ

       @param b ¹ԲΤΥ֥å
    */
    public void addValid(final Block b) {
	validBlocks.add(b);
    }

    /**
       ¹Բʥ֥åɲäޤ

       @param b ¹ԲΥ֥å
    */
    public void addInvalid(final Block b) {
	invalidBlocks.add(b);
    }

    /**
       ֥åɲäޤ

       @param b ֥å
       @param isValid ֥åμ¹ԲȽƤtrue
    */
    public void add(final Block b, final boolean isValid) {
	(isValid ? validBlocks : invalidBlocks).add(b);
    }

    /**
       եդ򤭤ޤ

       @throws CorruptedFileException եι¤Ƥ뤳Ȥ򸡽
    */
    public void solve() throws CorruptedFileException {
	int size = invalidBlocks.size();
	while (size > 0) {
	    Block e;
	    while ((e = invalidBlocks.poll()) != null) {
		e.validate(this);
	    }
	    while ((e = validBlocks.poll()) != null) {
		e.validateSides(this);
	    }
	    int nextSize = invalidBlocks.size();
	    if (nextSize == size) {
		throw new CorruptedFileException("graph is unsolvable: "
						 + nextSize);
	    }
	    size = nextSize;
	}
    }
}
